<?php
/** 
Plugin Name: PerfBoost - Per Page Module
Plugin URI: //1.envato.market/coderevolution
Description: This plugin will temporarily deactivate other idle plugins per page
Author: CodeRevolution
Version: 1.0.0
Author URI: //coderevolution.ro
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: perfboost-scheduled-plugin-deactivator
*/
/*  
Copyright 2016 - 2023 CodeRevolution
*/
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
if( get_option('perfboost_status') != 'active' ){
	return;
}
if ( ! is_admin() && ( !defined( 'DOING_AJAX' ) || !DOING_AJAX ) ) 
{
    add_filter( 'option_active_plugins', 'perfboost_filter_plugins' );
}
function perfboost_filter_plugins($plugins)
{
    global $wp;
	$remove_plugins = array();
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    $rules = get_option('perfboost_page_list', array());
    if (!function_exists('get_plugins')) 
    {
        require_once ABSPATH . 'wp-admin/includes/plugin.php';
    }
    $all_plugins = get_plugins();
    $current_page_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
	$current_page_url = trim( $current_page_url, "/" );
    $current_page_url = str_replace( '/?', '?', $current_page_url);
    foreach($rules as $id => $xr)
    {
        if(isset($xr[1]) && $xr[1] == '1')
        {
            $schedule = $xr[0];
            if( $schedule !== 'all' ){
                $device_name = perfboost_detect_device();
				if( $schedule !== $device_name){
					if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                        perfboost_log_to_file('Device not matched, skipping. Rule: ' . esc_html($schedule) . ' - device: ' . $device_name);
                    }
                    continue;
				}
			}
            if(!isset($xr[3]))
            {
                perfboost_log_to_file('Incorrect rule data provided for per page rules: ' . print_r($xr, true));
                continue;
            }
            else
            {
                $date = $xr[3];
            }
            $post_status  = $xr[2];
            if($post_status != 'activate' && $post_status !== 'deactivate')
            {
                perfboost_log_to_file('Incorrect rule activation data provided for per page rules: ' . print_r($xr, true));
                continue;
            }
            $name = $xr[4];
            $value = trim(trim($xr[5], "/"));
            $value = str_replace( '/?', '?', $value);
            foreach($date as $mplug)
            {
                if(array_key_exists($mplug, $all_plugins))
                {
                    if($value != '' && $value != '*')
                    {
                        if($name == 'equals')
                        {
                            if( $current_page_url == $value )
                            {
                                if( $post_status == 'activate' )
                                {
									$plkey = array_search( $mplug, $plugins );
									if( $plkey === false )
                                    { 
                                        $plugins[] = $mplug; 
                                    }
								}
                                else
                                {
									$remove_plugins[$mplug] = $mplug;
								}
                            }
                        }
                        elseif($name == 'notequals'){
							if( $current_page_url != $value )
                            {
                                if( $post_status == 'activate' )
                                {
									$plkey = array_search( $mplug, $plugins );
									if( $plkey === false )
                                    { 
                                        $plugins[] = $mplug; 
                                    }
								}
                                else
                                {
									$remove_plugins[$mplug] = $mplug;
								}
                            }
						}
                        elseif($name == 'contains'){
							if( function_exists('fnmatch') && fnmatch($value, $current_page_url) )
                            {
                                if( $post_status == 'activate' )
                                {
									$plkey = array_search( $mplug, $plugins );
									if( $plkey === false )
                                    { 
                                        $plugins[] = $mplug; 
                                    }
								}
                                else
                                {
									$remove_plugins[$mplug] = $mplug;
								}
                            }
						}

						if($name == 'notcontains'){
							if( function_exists('fnmatch') &&  !fnmatch($value, $current_page_url) )
                            {
                                if( $post_status == 'activate' )
                                {
									$plkey = array_search( $mplug, $plugins );
									if( $plkey === false )
                                    { 
                                        $plugins[] = $mplug; 
                                    }
								}
                                else
                                {
									$remove_plugins[$mplug] = $mplug;
								}
                            }
						}
                    }
                    else
                    {
                        if( $post_status == 'activate' )
                        {
                            $plkey = array_search( $mplug, $plugins );
							if( $plkey === false )
                            { 
                                $plugins[] = $mplug; 
                            }
						}
                        else
                        {
                            $remove_plugins[$mplug] = $mplug;
                        }
                    }
                }
            }
            $plugins = array_diff( $plugins, $remove_plugins );
        }
    }
    return $plugins;
}

function perfboost_detect_device()
{
  	$deviceName="";
  	$userAgent = $_SERVER["HTTP_USER_AGENT"];
  	$devicesTypes = array(
	    "desktop" => array(
	    	"msie 10", 
	    	"msie 9", 
	    	"msie 8", 
	    	"windows.*firefox", 
	    	"windows.*chrome", 
	    	"x11.*chrome", 
	    	"x11.*firefox", 
	    	"macintosh.*chrome", 
	    	"macintosh.*firefox", 
	    	"opera"
	    ),
	    "tablet" => array(
	    	"tablet", 
	    	"android", 
	    	"ipad", 
	    	"tablet.*firefox"
	    ),
	    "mobile" => array(
	    	"mobile ", 
	    	"android.*mobile", 
	    	"iphone", 
	    	"ipod", 
	    	"opera mobi", 
	    	"opera mini",
	    	"blackberry"
	    ),
	    "bot" => array(
	    	"googlebot", 
	    	"mediapartners-google", 
	    	"adsbot-google", 
	    	"duckduckbot", 
	    	"msnbot", 
	    	"bingbot", 
	    	"ask", 
	    	"facebook", 
	    	"yahoo", 
	    	"addthis"
	    )
    );
  	foreach($devicesTypes as $deviceType => $devices) {
        foreach($devices as $device) {
            if( preg_match( "/" . $device . "/i", $userAgent ) ) {
                $deviceName = $deviceType;
                break;
            }
        }
    }
    return $deviceName;
}
?>