<?php
/** 
Plugin Name: PerfBoost - Scheduled Plugin Manager
Plugin URI: //1.envato.market/coderevolution
Description: This plugin will temporarily deactivate other idle plugins and boots the performance of your site
Author: 20script
Version: 1.0.3.1
Author URI: https://www.20script.ir
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: perfboost-scheduled-plugin-deactivator
*/
/*  
Copyright 2016 - 2023 CodeRevolution
*/
defined('ABSPATH') or die();
require_once (dirname(__FILE__) . "/res/other/plugin-dash.php"); 

function perfboost_load_textdomain() {
    load_plugin_textdomain( 'perfboost-scheduled-plugin-deactivator', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'init', 'perfboost_load_textdomain' );


function perfboost_assign_var(&$target, $var, $root = false) {
	static $cnt = 0;
    $key = key($var);
    if(is_array($var[$key])) 
        perfboost_assign_var($target[$key], $var[$key], false);
    else {
        if($key==0)
		{
			if($cnt == 0 && $root == true)
			{
				$target['_perfboostr_nonce'] = $var[$key];
				$cnt++;
			}
			elseif($cnt == 1 && $root == true)
			{
				$target['_wp_http_referer'] = $var[$key];
				$cnt++;
			}
			else
			{
				$target[] = $var[$key];
			}
		}
        else
		{
            $target[$key] = $var[$key];
		}
    }   
}

$plugin = plugin_basename(__FILE__);
if(is_admin())
{
    if($_SERVER["REQUEST_METHOD"]==="POST" && !empty($_POST["coderevolution_max_input_var_data"])) {
    $vars = explode("&", $_POST["coderevolution_max_input_var_data"]);
    $coderevolution_max_input_var_data = array();
    foreach($vars as $var) {
        parse_str($var, $variable);
        perfboost_assign_var($_POST, $variable, true);
    }
	unset($_POST["coderevolution_max_input_var_data"]);
}
    $plugin_slug = explode('/', $plugin);
    $plugin_slug = $plugin_slug[0];
    if(isset($_POST[$plugin_slug . '_register']) && isset($_POST[$plugin_slug. '_register_code']) && trim($_POST[$plugin_slug . '_register_code']) != '')
    {
        update_option('coderevolution_settings_changed', 1);
        if(strlen(trim($_POST[$plugin_slug . '_register_code'])) != 36 || strstr($_POST[$plugin_slug . '_register_code'], '-') == false)
        {
            perfboost_log_to_file('Invalid registration code submitted: ' . $_POST[$plugin_slug . '_register_code']);
        }
        else
        {
            $ch = curl_init('https://wpinitiate.com/verify-purchase/purchase.php');
            if($ch !== false)
            {
                $data           = array();
                $data['code']   = trim($_POST[$plugin_slug . '_register_code']);
                $data['siteURL']   = get_bloginfo('url');
                $data['siteName']   = get_bloginfo('name');
                $data['siteEmail']   = get_bloginfo('admin_email');
                $fdata = "";
                foreach ($data as $key => $val) {
                    $fdata .= "$key=" . urlencode(trim($val)) . "&";
                }
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                $result = curl_exec($ch);
                if($result === false)
                {
                    perfboost_log_to_file('Failed to get verification response: ' . curl_error($ch));
                }
                else
                {
                    $rj = json_decode($result, true);
                    if(isset($rj['error']))
                    {
                        update_option('coderevolution_settings_changed', $rj['error']);
                    }
                    elseif(isset($rj['item_name']))
                    {
                        $rj['code'] = $_POST[$plugin_slug . '_register_code'];
                        if($rj['item_id'] == '25501248' || $rj['item_id'] == '13371337' || $rj['item_id'] == '19200046')
                        {
                            update_option($plugin_slug . '_registration', $rj);
                            update_option('coderevolution_settings_changed', 2);
                        }
                        else
                        {
                            perfboost_log_to_file('Invalid response from purchase code verification (are you sure you inputed the right purchase code?): ' . print_r($rj, true));
                        }
                    }
                    else
                    {
                        perfboost_log_to_file('Invalid json from purchase code verification: ' . print_r($result, true));
                    }
                }
                curl_close($ch);
            }
            else
            {
                perfboost_log_to_file('Failed to init curl when trying to make purchase verification.');
            }
        }
    }
    if(isset($_POST[$plugin_slug . '_revoke_license']) && trim($_POST[$plugin_slug . '_revoke_license']) != '')
    {
        $ch = curl_init('https://wpinitiate.com/verify-purchase/revoke.php');
        if($ch !== false)
        {
            $data           = array();
            $data['siteURL']   = get_bloginfo('url');
            $fdata = "";
            foreach ($data as $key => $val) {
                $fdata .= "$key=" . urlencode(trim($val)) . "&";
            }
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            $result = curl_exec($ch);
            
            if($result === false)
            {
                perfboost_log_to_file('Failed to revoke verification response: ' . curl_error($ch));
                update_option($plugin_slug . '_registration', false);
            }
            else
            {
                update_option($plugin_slug . '_registration', false);
            }
        }
        else
        {
            perfboost_log_to_file('Failed to init curl to revoke verification response.');
        }
    }
    $uoptions = get_option($plugin_slug . '_registration', array());
    if(isset($uoptions['item_id']) && isset($uoptions['item_name']) && isset($uoptions['created_at']) && isset($uoptions['buyer']) && isset($uoptions['licence']) && isset($uoptions['supported_until']))
    {
        require "update-checker/plugin-update-checker.php";
        $fwdu3dcarPUC = YahnisElsts\PluginUpdateChecker\v5\PucFactory::buildUpdateChecker("https://wpinitiate.com/auto-update/?action=get_metadata&slug=perfboost-scheduled-plugin-deactivator", __FILE__, "perfboost-scheduled-plugin-deactivator");
    }
    else
    {
        add_action("after_plugin_row_{$plugin}", function( $plugin_file, $plugin_data, $status ) {
            $plugin_url = 'https://codecanyon.net/item/perfboost-scheduled-plugin-manager-boost-wordpress-performance/25501248';
            echo '<tr class="active"><td>&nbsp;</td><td colspan="2"><p class="cr_auto_update">';
          echo sprintf( wp_kses( __( 'The plugin is not registered. Automatic updating is disabled. Please purchase a license for it from <a href="%s" target="_blank">here</a> and register  the plugin from the \'Main Settings\' menu using your purchase code. <a href="%s" target="_blank">How I find my purchase code?', 'perfboost-scheduled-plugin-deactivator'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url( 'https://1.envato.market/c/1264868/275988/4415?u=' . urlencode($plugin_url)), esc_url('//www.youtube.com/watch?v=NElJ5t_Wd48') );     
          echo '</a></p> </td></tr>';
        }, 10, 3 );
        add_action('admin_enqueue_scripts', 'perfboost_admin_enqueue_all');
        add_filter("plugin_action_links_$plugin", 'perfboost_add_activation_link');
    }
    add_action('admin_menu', 'perfboost_register_my_custom_menu_page');
    add_action('network_admin_menu', 'perfboost_register_my_custom_menu_page');
    add_filter("plugin_action_links_$plugin", 'perfboost_add_support_link');
    add_filter("plugin_action_links_$plugin", 'perfboost_add_settings_link');
    add_filter("plugin_action_links_$plugin", 'perfboost_add_rating_link');
    add_action('admin_head', 'perfboost_register_mysettings');
    add_action('admin_init', 'perfboost_register_mysettings_settings');
    require(dirname(__FILE__) . "/res/perfboost-main.php");
    require(dirname(__FILE__) . "/res/perfboost-poster.php");
    require(dirname(__FILE__) . "/res/perfboost-rules-list.php");
    require(dirname(__FILE__) . "/res/perfboost-page-list.php");
    require(dirname(__FILE__) . "/res/perfboost-logs.php");
}
function perfboost_initialize_mu_plugin( $networkwide ){
    if( is_multisite() && $networkwide ){
    }
    else
    {
        require dirname(__FILE__) . '/plugin-activation.php';
        update_option('perfboost_status', 'active');
    }
}
register_activation_hook( __FILE__, 'perfboost_initialize_mu_plugin' );
function perfboost_admin_enqueue_all()
{
    $reg_css_code = '.cr_auto_update{background-color:#fff8e5;margin:5px 20px 15px 20px;border-left:4px solid #fff;padding:12px 12px 12px 12px !important;border-left-color:#ffb900;}';
    wp_register_style( 'perfboost-plugin-reg-style', false );
    wp_enqueue_style( 'perfboost-plugin-reg-style' );
    wp_add_inline_style( 'perfboost-plugin-reg-style', $reg_css_code );
}

function perfboost_add_activation_link($links)
{
    $settings_link = '<a href="admin.php?page=perfboost_admin_settings">' . esc_html__('Activate Plugin License', 'perfboost-scheduled-plugin-deactivator') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function perfboost_register_my_custom_menu_page()
{
    add_menu_page('PerfBoost', 'PerfBoost', 'manage_options', 'perfboost_admin_settings', 'perfboost_admin_settings', plugins_url('images/icon.png', __FILE__));
    $main = add_submenu_page('perfboost_admin_settings', esc_html__("Main Settings", 'perfboost-scheduled-plugin-deactivator'), esc_html__("Main Settings", 'perfboost-scheduled-plugin-deactivator'), 'manage_options', 'perfboost_admin_settings');
    add_action( 'load-' . $main, 'perfboost_load_all_admin_js' );
    add_action( 'load-' . $main, 'perfboost_load_main_admin_js' );
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if (isset($perfboost_Main_Settings['perfboost_enabled']) && $perfboost_Main_Settings['perfboost_enabled'] == 'on') {
        $latest = add_submenu_page('perfboost_admin_settings', esc_html__('Scheduled Rules', 'perfboost-scheduled-plugin-deactivator'), esc_html__('Scheduled Rules', 'perfboost-scheduled-plugin-deactivator'), 'manage_options', 'perfboost_items_panel', 'perfboost_items_panel');
        add_action( 'load-' . $latest, 'perfboost_load_admin_js' );
        add_action( 'load-' . $latest, 'perfboost_load_all_admin_js' );
        $page = add_submenu_page('perfboost_admin_settings', esc_html__('URL Rules', 'perfboost-scheduled-plugin-deactivator'), esc_html__('URL Rules', 'perfboost-scheduled-plugin-deactivator'), 'manage_options', 'perfboost_page_panel', 'perfboost_page_panel');
        add_action( 'load-' . $page, 'perfboost_load_admin_js' );
        add_action( 'load-' . $page, 'perfboost_load_all_admin_js' );
        $poster = add_submenu_page('perfboost_admin_settings', esc_html__('Post Publish Actions', 'perfboost-scheduled-plugin-deactivator'), esc_html__('Post Publish Actions', 'perfboost-scheduled-plugin-deactivator'), 'manage_options', 'perfboost_poster_panel', 'perfboost_poster_panel');
        add_action( 'load-' . $poster, 'perfboost_load_all_admin_js' );
        $logs = add_submenu_page('perfboost_admin_settings', esc_html__("Activity & Logging", 'perfboost-scheduled-plugin-deactivator'), esc_html__("Activity & Logging", 'perfboost-scheduled-plugin-deactivator'), 'manage_options', 'perfboost_logs', 'perfboost_logs');
        add_action( 'load-' . $logs, 'perfboost_load_all_admin_js' );
    }
}
function perfboost_load_admin_js(){
    add_action('admin_enqueue_scripts', 'perfboost_enqueue_admin_js');
}

function perfboost_enqueue_admin_js(){
    wp_enqueue_script('perfboost-footer-script', plugins_url('scripts/footer.js', __FILE__), array('jquery'), false, true);
    $cr_miv = ini_get('max_input_vars');
	if($cr_miv === null || $cr_miv === false || !is_numeric($cr_miv))
	{
        $cr_miv = '9999999';
    }
    $footer_conf_settings = array(
        'max_input_vars' => $cr_miv,
        'plugin_dir_url' => plugin_dir_url(__FILE__),
        'ajaxurl' => admin_url('admin-ajax.php')
    );
    wp_localize_script('perfboost-footer-script', 'mycustomsettings', $footer_conf_settings);
    wp_register_style('perfboost-rules-style', plugins_url('styles/perfboost-rules.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('perfboost-rules-style');
}
function perfboost_load_main_admin_js(){
    add_action('admin_enqueue_scripts', 'perfboost_enqueue_main_admin_js');
}

function perfboost_enqueue_main_admin_js(){
    wp_enqueue_script('perfboost-main-script', plugins_url('scripts/main.js', __FILE__), array('jquery'));
}
function perfboost_load_all_admin_js(){
    add_action('admin_enqueue_scripts', 'perfboost_admin_load_files');
}
function perfboost_add_rating_link($links)
{
    $settings_link = '<a href="//codecanyon.net/downloads" target="_blank" title="Rate">
            <i class="wdi-rate-stars"><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></i></a>';
    array_push($links, $settings_link);
    return $links;
}

function perfboost_add_support_link($links)
{
    $settings_link = '<a href="//coderevolution.ro/knowledge-base/" target="_blank">' . esc_html__('Support', 'perfboost-scheduled-plugin-deactivator') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function perfboost_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=perfboost_admin_settings">' . esc_html__('Settings', 'perfboost-scheduled-plugin-deactivator') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter('cron_schedules', 'perfboost_add_cron_schedule');
function perfboost_add_cron_schedule($schedules)
{
    $schedules['perfboost_cron'] = array(
        'interval' => 600,
        'display' => esc_html__('PerfBoost Cron', 'perfboost-scheduled-plugin-deactivator')
    );
    $schedules['minutely'] = array(
        'interval' => 60,
        'display' => esc_html__('Once A Minute', 'perfboost-scheduled-plugin-deactivator')
    );
    $schedules['weekly']        = array(
        'interval' => 604800,
        'display' => esc_html__('Once Weekly', 'perfboost-scheduled-plugin-deactivator')
    );
    $schedules['monthly']       = array(
        'interval' => 2592000,
        'display' => esc_html__('Once Monthly', 'perfboost-scheduled-plugin-deactivator')
    );
    return $schedules;
}
function perfboost_auto_clear_log()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists(WP_CONTENT_DIR . '/perfboost_info.log')) {
        $wp_filesystem->delete(WP_CONTENT_DIR . '/perfboost_info.log');
    }
}

register_deactivation_hook(__FILE__, 'perfboost_my_deactivation');
function perfboost_my_deactivation()
{
    update_option('perfboost_status', 'notactive');
    if ( defined( 'WPMU_PLUGIN_DIR' ) ) {
        $perfboost_mu_plugins_path = WPMU_PLUGIN_DIR;
    } else {
        $perfboost_mu_plugins_path = WP_CONTENT_DIR . '/' . 'mu-plugins';
    }
    $perfboost_mu_plugin_file_path = $perfboost_mu_plugins_path . '/perfboost-mu-plugin.php';
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
       include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists($perfboost_mu_plugin_file_path)) {
        $wp_filesystem->delete($perfboost_mu_plugin_file_path);
    }
    wp_clear_scheduled_hook('perfboostaction');
    wp_clear_scheduled_hook('perfboostactionclear');
    $running = array();
    update_option('perfboost_running_list', $running, false);
}
add_action('perfboostaction', 'perfboost_cron', 1, 2);
add_action('perfboostactionclear', 'perfboost_auto_clear_log');

function perfboost_cron_schedule()
{
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if (isset($perfboost_Main_Settings['perfboost_enabled']) && $perfboost_Main_Settings['perfboost_enabled'] === 'on') 
    {
        if(isset($_POST['perfboost_rules_list']))
        {
            $GLOBALS['wp_object_cache']->delete('perfboost_rules_list', 'options');
            $rules = get_option('perfboost_rules_list', array());
            if(function_exists('wp_unschedule_hook'))
            {
                wp_unschedule_hook('perfboostaction');
            }
            else
            {
                $xcrons = _get_cron_array();
                foreach( $xcrons as $timestamp => $cron ) {
                    if ( ! empty( $cron['perfboostaction'] ) )  {
                        unset( $xcrons[$timestamp]['perfboostaction'] );
                    }

                    if ( empty( $xcrons[$timestamp] ) ) {
                        unset( $xcrons[$timestamp] );
                    }
                }
                _set_cron_array( $xcrons );
            }
            foreach($rules as $id => $xr)
            {
                if(isset($xr[1]) && $xr[1] == '1')
                {
                    if (isset($xr[0])) 
                    {
                        $date1 = new DateTime('today ' . $xr[0], perfboost_get_blog_timezone());
                        $number1 = (int) $date1->format('U');
                        if($number1 <= current_time('timestamp'))
                        {
                            $date1 = new DateTime('tomorrow ' . $xr[0], perfboost_get_blog_timezone());
                            $number1 = (int) $date1->format('U');
                        }
                        $rez = wp_schedule_event($number1, 'daily', 'perfboostaction', array($id, $xr));
                        if ($rez === FALSE) {
                            perfboost_log_to_file('[Scheduler] Failed to schedule perfboostaction - '  . $id . ' to perfboost_cron!');
                        }
                    }
                }
            }
        }
        if (isset($perfboost_Main_Settings['enable_logging']) && $perfboost_Main_Settings['enable_logging'] === 'on' && isset($perfboost_Main_Settings['auto_clear_logs']) && $perfboost_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('perfboostactionclear')) {
                $rez = wp_schedule_event(time(), $perfboost_Main_Settings['auto_clear_logs'], 'perfboostactionclear');
                if ($rez === FALSE) {
                    perfboost_log_to_file('[Scheduler] Failed to schedule perfboostactionclear to ' . $perfboost_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('perfboost_schedule_time', $perfboost_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('perfboost_schedule_time')) {
                    wp_clear_scheduled_hook('perfboostactionclear');
                    $rez = wp_schedule_event(time(), $perfboost_Main_Settings['auto_clear_logs'], 'perfboostactionclear');
                    add_option('perfboost_schedule_time', $perfboost_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        perfboost_log_to_file('[Scheduler] Failed to schedule perfboostactionclear to ' . $perfboost_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('perfboost_schedule_time');
                    if ($the_time != $perfboost_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('perfboostactionclear');
                        delete_option('perfboost_schedule_time');
                        $rez = wp_schedule_event(time(), $perfboost_Main_Settings['auto_clear_logs'], 'perfboostactionclear');
                        add_option('perfboost_schedule_time', $perfboost_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            perfboost_log_to_file('[Scheduler] Failed to schedule perfboostactionclear to ' . $perfboost_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('perfboostactionclear')) {
                delete_option('perfboost_schedule_time');
            } else {
                wp_clear_scheduled_hook('perfboostactionclear');
                delete_option('perfboost_schedule_time');
            }
        }
    } else {
        if(function_exists('wp_unschedule_hook'))
        {
            wp_unschedule_hook('perfboostaction');
        }
        else
        {
            $xcrons = _get_cron_array();
            foreach( $xcrons as $timestamp => $cron ) {
                if ( ! empty( $cron['perfboostaction'] ) )  {
                    unset( $xcrons[$timestamp]['perfboostaction'] );
                }
                if ( empty( $xcrons[$timestamp] ) ) {
                    unset( $xcrons[$timestamp] );
                }
            }
            _set_cron_array( $xcrons );
        }
        if (!wp_next_scheduled('perfboostactionclear')) {
            delete_option('perfboost_schedule_time');
        } else {
            wp_clear_scheduled_hook('perfboostactionclear');
            delete_option('perfboost_schedule_time');
        }
    }
}
function perfboost_cron($id, $xr)
{
    perfboost_run_rule($id, $xr);
}

function perfboost_log_to_file($str)
{
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if (isset($perfboost_Main_Settings['enable_logging']) && $perfboost_Main_Settings['enable_logging'] == 'on') {
        $d = date("j-M-Y H:i:s e", current_time( 'timestamp' ));
        error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/perfboost_info.log');
    }
}

add_action('wp_ajax_perfboost_my_action', 'perfboost_my_action_callback');
function perfboost_my_action_callback()
{
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    $failed                 = false;
    $del_id                 = $_POST['id'];
    $type                   = $_POST['type'];
    $how                    = $_POST['how'];
    if($how == 'duplicate')
    {
        if($type == '0')
        {
            $GLOBALS['wp_object_cache']->delete('perfboost_rules_list', 'options');
            $rules = get_option('perfboost_rules_list', array());
            if (!empty($rules)) {
                $found            = 0;
                $cont = 0;
                foreach ($rules as $request => $bundle[]) {
                    if ($cont == $del_id) {
                        $copy_bundle = $rules[$request];
                        $rules[] = $copy_bundle;
                        $found   = 1;
                        break;
                    }
                    $cont = $cont + 1;
                }
                if($found == 0)
                {
                    perfboost_log_to_file('perfboost_rules_list index not found: ' . $del_id);
                    echo 'nochange';
                    die();
                }
                else
                {
                    update_option('perfboost_rules_list', $rules, false);
                    echo 'ok';
                    die();
                }
            } else {
                perfboost_log_to_file('perfboost_rules_list empty!');
                echo 'nochange';
                die();
            }
        }
        elseif($type == '1')
        {
            $GLOBALS['wp_object_cache']->delete('perfboost_page_list', 'options');
            $rules = get_option('perfboost_page_list', array());
            if (!empty($rules)) {
                $found            = 0;
                $cont = 0;
                foreach ($rules as $request => $bundle[]) {
                    if ($cont == $del_id) {
                        $copy_bundle = $rules[$request];
                        $rules[] = $copy_bundle;
                        $found   = 1;
                        break;
                    }
                    $cont = $cont + 1;
                }
                if($found == 0)
                {
                    perfboost_log_to_file('perfboost_page_list index not found: ' . $del_id);
                    echo 'nochange';
                    die();
                }
                else
                {
                    update_option('perfboost_page_list', $rules, false);
                    echo 'ok';
                    die();
                }
            } else {
                perfboost_log_to_file('perfboost_page_list empty!');
                echo 'nochange';
                die();
            }
        }
    }
    $force_delete           = true;
    $number                 = 0;
    if ($how == 'trash') {
        $force_delete = false;
    }
    $post_list = array();
    $postsPerPage = 50000;
    $paged = 0;
    do
    {
        $postOffset = $paged * $postsPerPage;
        $query = array(
            'post_status' => array(
                'publish',
                'draft',
                'pending',
                'trash',
                'private',
                'future'
            ),
            'post_type' => array(
                'any'
            ),
            'numberposts' => $postsPerPage,
            'meta_key' => 'perfboost_parent_rule',
            'fields' => 'ids',
            'offset'  => $postOffset
        );
        $got_me = get_posts($query);
        $post_list = array_merge($post_list, $got_me);
        $paged++;
    }while(!empty($got_me));
    wp_suspend_cache_addition(true);
    foreach ($post_list as $post) {
        $index = get_post_meta($post, 'perfboost_parent_rule', true);
        if ($index == $type . '-' . $del_id) {
            $args             = array(
                'post_parent' => $post
            );
            $post_attachments = get_children($args);
            if (isset($post_attachments) && !empty($post_attachments)) {
                foreach ($post_attachments as $attachment) {
                    wp_delete_attachment($attachment->ID, true);
                }
            }
            $res = wp_delete_post($post, $force_delete);
            if ($res === false) {
                $failed = true;
            } else {
                $number++;
            }
        }
    }
    wp_suspend_cache_addition(false);
    if ($failed === true) {
        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
            perfboost_log_to_file('[PostDelete] Failed to delete all posts for rule id: ' . esc_html($del_id) . '!');
        }
        echo 'failed';
    } else {
        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
            perfboost_log_to_file('[PostDelete] Successfuly deleted ' . esc_html($number) . ' posts for rule id: ' . esc_html($del_id) . '!');
        }
        if ($number == 0) {
            echo 'nochange';
        } else {
            echo 'ok';
        }
    }
    die();
}

add_action('wp_ajax_perfboost_run_my_action', 'perfboost_run_my_action_callback');
function perfboost_run_my_action_callback()
{
    $run_id = $_POST['id'];
    echo perfboost_run_rule($run_id);
    die();
}

function perfboost_clearFromList($param, $type)
{
    $GLOBALS['wp_object_cache']->delete('perfboost_running_list', 'options');
    $running = get_option('perfboost_running_list');
    if($running !== false)
    {
        $key = array_search(array(
            $param => $type
        ), $running);
        if ($key !== FALSE) {
            unset($running[$key]);
            update_option('perfboost_running_list', $running);
        }
    }
}
add_action('transition_post_status', 'perfboost_new_post', PHP_INT_MIN, 3);
function perfboost_new_post($new_status, $old_status, $post)
{
    if ('publish' !== $new_status or 'publish' === $old_status)
    {
        return;
    }
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if (isset($perfboost_Main_Settings['perfboost_enabled']) && $perfboost_Main_Settings['perfboost_enabled'] == 'on') 
    {
        $perfboost_Poster_Settings = get_option('perfboost_Poster_Settings', false);
        if (isset($perfboost_Poster_Settings['perfboost_posting']) && $perfboost_Poster_Settings['perfboost_posting'] == 'on')
        {
            perfboost_do_post();
        }
    }
}
function perfboost_do_post()
{
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if (isset($perfboost_Main_Settings['perfboost_enabled']) && $perfboost_Main_Settings['perfboost_enabled'] == 'on') 
    {
        $perfboost_Poster_Settings = get_option('perfboost_Poster_Settings', false);
        $nw = false;
        $nh = false;
        if (!function_exists('get_plugins')) 
        {
            require_once ABSPATH . 'wp-admin/includes/plugin.php';
        }
        $all_plugins = get_plugins();
        $post_status  = $perfboost_Poster_Settings['activate_deactivate'];
        if (isset($perfboost_Poster_Settings['network_wide']) && $perfboost_Poster_Settings['network_wide'] == 'on') 
        {
            $nw = true;
        }
        else
        {
            $nw = false;
        }
        if (isset($perfboost_Poster_Settings['no_hook']) && $perfboost_Poster_Settings['no_hook'] == 'on') 
        {
            $nh = true;
        }
        else
        {
            $nh = false;
        }
        if(!function_exists('is_plugin_active'))
        {
            include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        }
        if(isset($perfboost_Poster_Settings['perfboost_posting']) && $perfboost_Poster_Settings['perfboost_posting'] == 'on')
        {
            if(isset($perfboost_Poster_Settings['plug_list']) && is_array($perfboost_Poster_Settings['plug_list']))
            {
                $date = $perfboost_Poster_Settings['plug_list'];
                foreach($date as $mplug)
                {
                    if(array_key_exists($mplug, $all_plugins))
                    {
                        if($post_status == 'activate')
                        {
                            if(!is_plugin_active($mplug))
                            {
                                $result = activate_plugins($mplug, '', $nw, $nh);
                                if ( is_wp_error( $result ) ) {
                                    perfboost_log_to_file('[AUTO] Failed to activate plugin: ' . esc_html($mplug) . ' Error: ' . esc_html($result->get_error_message()));
                                }
                                else
                                {
                                    if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                                        perfboost_log_to_file('[AUTO] Plugin activated successfully: ' . esc_html($mplug) . ' ' . print_r($result, true));
                                    }
                                }
                            }
                        }
                        elseif($post_status == 'deactivate')
                        {
                            if(is_plugin_active($mplug))
                            {
                                $result = deactivate_plugins($mplug, $nh, $nw);
                                if ( is_wp_error( $result ) ) {
                                   perfboost_log_to_file('[AUTO] Failed to activate plugin: ' . esc_html($mplug) . ' Error: ' . esc_html($result->get_error_message()));
                                }
                                else
                                {
                                    if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                                        perfboost_log_to_file('[AUTO] Plugin activated successfully: ' . esc_html($mplug));
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                                perfboost_log_to_file('[AUTO] Incorrect switch status given: ' . esc_html($post_status));
                            }
                        }
                    }
                    else
                    {
                        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                            perfboost_log_to_file('[AUTO] Plugin ' . esc_html($mplug) . ' no longer seems to be installed. Nothing to do.');
                        }
                    }
                }
                if(count($date) > 0 && isset($perfboost_Poster_Settings['revert_after']) && $perfboost_Poster_Settings['revert_after'] != '')
                {
                    if(wp_next_scheduled('perfboost_revert_new_post', array( $date, $post_status, $nw, $nh )))
                    {
                        wp_clear_scheduled_hook('perfboost_revert_new_post', array( $date, $post_status, $nw, $nh ));
                    }
                    wp_schedule_single_event( time() + intval($perfboost_Poster_Settings['revert_after']), 'perfboost_revert_new_post', array( $date, $post_status, $nw, $nh ) );
                }
            }
        }
    }
    return;
}
function perfboost_revert_status( $date, $post_status, $nw, $nh ) 
{
    if($post_status == 'activate')
    {
        $post_status = 'deactivate';
    }
    else
    {
        $post_status = 'activate';
    }
    if (!function_exists('get_plugins')) 
    {
        require_once ABSPATH . 'wp-admin/includes/plugin.php';
    }
    $all_plugins = get_plugins();
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if(!function_exists('is_plugin_active'))
    {
        include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
    }
    foreach($date as $mplug)
    {
        if(array_key_exists($mplug, $all_plugins))
        {
            if($post_status == 'activate')
            {
                if(!is_plugin_active($mplug))
                {
                    $result = activate_plugins($mplug, '', $nw, $nh);
                    if ( is_wp_error( $result ) ) {
                        perfboost_log_to_file('[REVERT] Failed to activate plugin: ' . esc_html($mplug) . ' Error: ' . esc_html($result->get_error_message()));
                    }
                    else
                    {
                        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                            perfboost_log_to_file('[REVERT] Plugin activated successfully: ' . esc_html($mplug) . ' ' . print_r($result, true));
                        }
                    }
                }
            }
            elseif($post_status == 'deactivate')
            {
                if(is_plugin_active($mplug))
                {
                    $result = deactivate_plugins($mplug, $nh, $nw);
                    if ( is_wp_error( $result ) ) {
                       perfboost_log_to_file('[REVERT] Failed to activate plugin: ' . esc_html($mplug) . ' Error: ' . esc_html($result->get_error_message()));
                    }
                    else
                    {
                        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                            perfboost_log_to_file('[REVERT] Plugin activated successfully: ' . esc_html($mplug));
                        }
                    }
                 }
            }
            else
            {
                if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                    perfboost_log_to_file('[REVERT] Incorrect switch status given: ' . esc_html($post_status));
               }
            }
        }
        else
        {
            if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                perfboost_log_to_file('[REVERT] Plugin ' . esc_html($mplug) . ' no longer seems to be installed. Nothing to do.');
            }
        }
    }
}
add_action( 'perfboost_revert_new_post', 'perfboost_revert_status', 10, 4 );
function perfboost_run_rule($param, $xr = array())
{
    $perfboost_Main_Settings = get_option('perfboost_Main_Settings', false);
    if (!function_exists('get_plugins')) 
    {
        require_once ABSPATH . 'wp-admin/includes/plugin.php';
    }
    $all_plugins = get_plugins();
    if(count($xr) == 0)
    {
        $GLOBALS['wp_object_cache']->delete('perfboost_rules_list', 'options');
        $rules = get_option('perfboost_rules_list', array());
        if(isset($rules[$param]))
        {
            $xr = $rules[$param];
        }
        else
        {
            perfboost_log_to_file('Inexistent rule ID provided: ' . esc_html($param) . ' rules map: ' . print_r($rules, true));
            return 'fail';
        }
    }
    if(!isset($xr[3]))
    {
        perfboost_log_to_file('Incorrect rule data provided: ' . print_r($xr, true));
        return 'fail';
    }
    else
    {
        $date = $xr[3];
    }
    $post_status  = $xr[2];
    if($post_status != 'activate' && $post_status !== 'deactivate')
    {
        perfboost_log_to_file('Incorrect rule activation data provided: ' . print_r($xr, true));
        return 'fail';
    }
    if(isset($xr[4]) && $xr[4] == '1')
    {
        $nw = true;
    }
    else
    {
        $nw = false;
    }
    if(isset($xr[5]) && $xr[5] == '1')
    {
        $nh = true;
    }
    else
    {
        $nh = false;
    }
    $mod = 0;
    if(!function_exists('is_plugin_active'))
    {
        include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
    }
    foreach($date as $mplug)
    {
        if(array_key_exists($mplug, $all_plugins))
        {
            if($post_status == 'activate')
            {
                if(!is_plugin_active($mplug))
                {
                    $result = activate_plugins($mplug, '', $nw, $nh);
                    if ( is_wp_error( $result ) ) {
                        perfboost_log_to_file('Failed to activate plugin: ' . esc_html($mplug) . ' Error: ' . esc_html($result->get_error_message()));
                    }
                    else
                    {
                        $mod++;
                        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                            perfboost_log_to_file('Plugin activated successfully: ' . esc_html($mplug) . ' ' . print_r($result, true));
                        }
                    }
                }
            }
            elseif($post_status == 'deactivate')
            {
                if(is_plugin_active($mplug))
                {
                    $result = deactivate_plugins($mplug, $nh, $nw);
                    if ( is_wp_error( $result ) ) {
                       perfboost_log_to_file('Failed to activate plugin: ' . esc_html($mplug) . ' Error: ' . esc_html($result->get_error_message()));
                    }
                    else
                    {
                        $mod++;
                        if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                            perfboost_log_to_file('Plugin activated successfully: ' . esc_html($mplug));
                        }
                    }
                }
            }
            else
            {
                if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                    perfboost_log_to_file('Incorrect switch status given: ' . esc_html($post_status));
                }
            }
        }
        else
        {
            if (isset($perfboost_Main_Settings['enable_detailed_logging'])) {
                perfboost_log_to_file('Plugin ' . esc_html($mplug) . ' no longer seems to be installed. Nothing to do.');
            }
        }
    }
    if($mod == 0)
    {
        return 'nochange';
    }
    return 'ok';
}

$perfboost_fatal = false;
function perfboost_clear_flag_at_shutdown($param, $type)
{
    $error = error_get_last();
    if ($error !== null && $error['type'] === E_ERROR && $GLOBALS['perfboost_fatal'] === false) {
        $GLOBALS['perfboost_fatal'] = true;
        $running = array();
        update_option('perfboost_running_list', $running);
        perfboost_log_to_file('[FATAL] Exit error: ' . $error['message'] . ', file: ' . $error['file'] . ', line: ' . $error['line'] . ' - rule ID: ' . $param . '!');
        perfboost_clearFromList($param, $type);
    }
    else
    {
        perfboost_clearFromList($param, $type);
    }
}

function perfboost_get_blog_timezone() {

    $tzstring = get_option( 'timezone_string' );
    $offset   = get_option( 'gmt_offset' );

    if( empty( $tzstring ) && 0 != $offset && floor( $offset ) == $offset ){
        $offset_st = $offset > 0 ? "-$offset" : '+'.absint( $offset );
        $tzstring  = 'Etc/GMT'.$offset_st;
    }
    if( empty( $tzstring ) ){
        $tzstring = 'UTC';
    }
    $timezone = new DateTimeZone( $tzstring );
    return $timezone; 
}

register_activation_hook(__FILE__, 'perfboost_activation_callback');
function perfboost_activation_callback($defaults = FALSE)
{
    if (!get_option('perfboost_Main_Settings') || $defaults === TRUE) {
        $perfboost_Main_Settings = array(
            'perfboost_enabled' => 'on',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'enable_detailed_logging' => ''
        );
        if ($defaults === FALSE) {
            add_option('perfboost_Main_Settings', $perfboost_Main_Settings);
        } else {
            update_option('perfboost_Main_Settings', $perfboost_Main_Settings);
        }
    }
    if (!get_option('perfboost_Poster_Settings') || $defaults === TRUE) {
        $perfboost_Poster_Settings = array(
            'perfboost_posting' => 'off',
            'plug_list' => '',
            'activate_deactivate' => 'activate',
            'no_hook' => '',
            'network_wide' => '',
            'revert_after' => ''
        );
        if ($defaults === FALSE) {
            add_option('perfboost_Poster_Settings', $perfboost_Poster_Settings);
        } else {
            update_option('perfboost_Poster_Settings', $perfboost_Poster_Settings);
        }
    }
}
register_activation_hook(__FILE__, 'perfboost_check_version');
function perfboost_check_version()
{
    if (!function_exists('curl_init')) {
        echo '<h3>'.esc_html__('Please enable curl PHP extension. Please contact your hosting provider\'s support to help you in this matter.', 'perfboost-scheduled-plugin-deactivator').'</h3>';
        die;
    }
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . esc_html__('You are not allowed to activate plugins!', 'perfboost-scheduled-plugin-deactivator') . '</p>';
        die;
    }
    $php_version_required = '5.6';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'perfboost-scheduled-plugin-deactivator'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard -> Updates to get the latest version of WordPress.', 'perfboost-scheduled-plugin-deactivator'), $wp_version_required) . '</p>';
        die;
    }
}
function perfboost_register_mysettings_settings()
{
    register_setting('perfboost_option_group', 'perfboost_Main_Settings');
    register_setting('perfboost_option_group2', 'perfboost_Poster_Settings');
    if (is_multisite()) {
        if (!get_option('perfboost_Main_Settings')) {
            perfboost_activation_callback(TRUE);
        }
    }
}
function perfboost_register_mysettings()
{
    perfboost_cron_schedule();
}
function perfboost_admin_load_files()
{
    wp_register_style('perfboost-browser-style', plugins_url('styles/perfboost-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('perfboost-browser-style');
    wp_register_style('perfboost-custom-style', plugins_url('styles/coderevolution-style.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('perfboost-custom-style');
    wp_enqueue_script('jquery');
    wp_enqueue_script( 'jquery-ui-resizable');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('thickbox');
    wp_enqueue_style('thickbox');
    $rating_th = get_option('perfboost_rating_trigger', false);
    if($rating_th === '1')
    {
        wp_enqueue_script( 'perfboost-rate-notice-js', plugins_url("js/rating.js", __FILE__));
        add_action( 'admin_notices', 'perfboost_five_star_wp_rate_notice');
    }
}
add_action('wp_ajax_perfboost-five-star-wp-rate', 'perfboost_rate_clicked');
function perfboost_rate_clicked()
{
    update_option('perfboost_rating_trigger', '2');
    die();
}
function perfboost_five_star_wp_rate_notice()
{
?>
<div class="notice notice-success is-dismissible perfboost-five-star-wp-rate-action">
<div>
	<?php echo sprintf( wp_kses( __( 'Hey, I noticed you are using the PerfBoost plugin for a while now - that\'s really awesome! Could you please do me a BIG favor and give it <b><a href=\'%s\' target=\'_blank\'>a 5-star rating on CodeCanyon</a></b>? Just to help us spread the word and boost our motivation. Thank you!', 'perfboost-scheduled-plugin-deactivator'), array(  'b' => array(), 'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url('//codecanyon.net/downloads') ); ?>
	<br/>
	<strong><em>Szabi Kisded - CodeRevolution</em></strong>
</div>
<ul>
	<li><a
	       href="//codecanyon.net/downloads" target="_blank"><?php echo esc_html__('Yes, you deserve it!', 'perfboost-scheduled-plugin-deactivator');?></a>
	</li>
	<li><a href="#"><?php echo esc_html__('I already did.', 'perfboost-scheduled-plugin-deactivator');?></a></li>
	<li><a href="#"><?php echo esc_html__('No, sorry.', 'perfboost-scheduled-plugin-deactivator');?></a></li>
</ul>
</div>
<?php
}
?>